local coveredBridge = ...

-- Apply building asset processor
coveredBridge:registerAssetProcessor("models/coveredBridge.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
coveredBridge:registerAssetProcessor("models/coveredBridgeLarge.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
coveredBridge:registerAssetProcessor("models/coveredBridgeDecoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
coveredBridge:registerAssetProcessor("models/coveredBridgeGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
coveredBridge:registerAssetProcessor("models/coveredBridgeAddition.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

_BridgeBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {1, 1} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
}}
_GateBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {8, 4} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
}}
coveredBridge:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")

-- Register all covered bridge building parts and their properties
coveredBridge:dofile("scripts/soldierBehaviorTree.lua")
coveredBridge:dofile("scripts/building_parts.lua")

function registerBridgeMonument(_option)
    -- Register the covered bridge monument
    coveredBridge:register({
	Id = CoveredBridgePrefix .. _option ,
	Name = CoveredBridgePrefix .. _option .. "_MONUMENT_NAME",
	Description = CoveredBridgePrefix .. _option .. "_MONUMENT_DESC",
	BuildingType = "MODS",
	IsManuallyUnlocked = false,
	IsDestructible = true,
	IsEditable = true,
	IsClearTrees = true,
        DataType = "BUILDING",
        AssetCoreBuildingPart = CoveredBridgePrefix .. _option .. "_CORE_PART",
        BuildingPartSetList = {
		{
			Name = CoveredBridgePrefix .. "_NAME",
	                BuildingPartList = {
		            CoveredBridgePrefix .. "_HOUSE_PART",
                            CoveredBridgePrefix .. "_RED_PART",
                            CoveredBridgePrefix .. "_GREEN_A_PART",
		            CoveredBridgePrefix .. "_GREEN_B_PART",
                            CoveredBridgePrefix .. "_BLUE_PART",
		            CoveredBridgePrefix .. "_RED_WINE_PART",
		            CoveredBridgePrefix .. "_CARBON_PART",
		            CoveredBridgePrefix .. "_CENTER_COVERAGE_PART",
		            CoveredBridgePrefix .. "_START_END_COVERAGE_PART",
		            CoveredBridgePrefix .. "_GATE_ROOT_PART"
	                }
                }
        }
    })
end
 
registerBridgeMonument("")
registerBridgeMonument("_LARGE")

